/*
 *		This Code Was Created By Lionel Brits & Jeff Molofee 2000
 *      The Code Was Modified By Justin Eslinger for Lesson 23
 *		If You've Found This Code Useful, Please Let Me Know.
 *		Visit My Site At nehe.gamedev.net
 */

/*
Code Modified By Dan Ricart
October 26, 2001
*/

#include <windows.h>									// Header File For Windows
#include <math.h>										// Math Library Header File
#include <stdio.h>										// Header File For Standard Input/Output
#include <gl\gl.h>										// Header File For The OpenGL32 Library
#include <gl\glu.h>										// Header File For The GLu32 Library
#include <gl\glaux.h>									// Header File For The Glaux Library
#include <dinput.h>										// Direct Input Functions ( Add )

LPDIRECTINPUT7			g_DI;							// Direct Input ( Add )
LPDIRECTINPUTDEVICE7	g_KDIDev;						// Keyboard Device ( Add )

HDC			hDC=NULL;									// Private GDI Device Context
HGLRC		hRC=NULL;									// Permanent Rendering Context
HWND		hWnd=NULL;									// Holds Our Window Handle
HINSTANCE	hInstance;									// Holds The Instance Of The Application

BYTE	buffer[256];									// (Modified... Removed 'keys[]')
bool	active=TRUE;									// Window Active Flag Set To TRUE By Default
bool	fullscreen=TRUE;								// Fullscreen Flag Set To Fullscreen Mode By Default
bool	blend;											// Blending ON/OFF
bool	bp;												// Blend Button Pressed? (Modified, Just The Caption)
bool	fp;												// F1 Button Pressed?

const	float piover180 = 0.0174532925f;
float	heading;
float	xpos;
float	zpos;

GLfloat	yrot;											// Y Rotation
GLfloat	walkbias = 0;
GLfloat	walkbiasangle = 0;
GLfloat	lookupdown = 0.0f;
GLfloat	z=0.0f;											// Depth Into The Screen

GLuint	texture[5];										// Storage For 5 Textures (Modified... We'll Need This Later)

typedef struct tagVERTEX
{
	float x, y, z;
	float u, v;
} VERTEX;

typedef struct tagTRIANGLE
{
	int texture;										// Used For Texturing ( Add )
	VERTEX vertex[3];
} TRIANGLE;

typedef struct tagSECTOR
{
	int numtriangles;
	TRIANGLE* triangle;
} SECTOR;

SECTOR sector1;											// Our Model Goes Here:

POINT mpos;												// Mouse Position	( Add )

int  adjust = 5;										// Speed Adjustment ( Add )

// Create A Structure For The Timer Information ( Add )
struct
{
  __int64       frequency;								// Timer Frequency
  float         resolution;								// Timer Resolution
  unsigned long mm_timer_start;     
  
  // Multimedia Timer Start Value
  unsigned long mm_timer_elapsed;						// Multimedia Timer Elapsed Time
  bool   performance_timer;    
  
  // Using The Performance Timer?
  __int64       performance_timer_start;				// Performance Timer Start Value
  __int64       performance_timer_elapsed;				// Performance Timer Elapsed Time
} timer;												// Structure Is Named 'timer'


LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc

// Initialize Our Timer (Get It Ready) ( Add )
void TimerInit(void)
{
     memset(&timer, 0, sizeof(timer));   
	 // Clear Our Timer Structure
     // Check To See If A Performance Counter Is Available
     // If One Is Available The Timer Frequency Will Be Updated
     if (!QueryPerformanceFrequency((LARGE_INTEGER *) &timer.frequency))
     {
          // No Performace Counter Available
          timer.performance_timer = FALSE;  
		  // Set Performance Timer To FALSE
          timer.mm_timer_start = timeGetTime();			// Use timeGetTime() To Get Current Time
          timer.resolution  = 1.0f/1000.0f;				// Set Our Timer Resolution To .001f
          timer.frequency   = 1000;   
		  // Set Our Timer Frequency To 1000
          timer.mm_timer_elapsed = timer.mm_timer_start;	// Set The Elapsed Time To The Current Time
     }
     else
     {
          // Performance Counter Is Available, Use It Instead Of The Multimedia Timer
          // Get The Current Time And Store It In performance_timer_start
          QueryPerformanceCounter((LARGE_INTEGER *) &timer.performance_timer_start);
          timer.performance_timer   = TRUE;    // Set Performance Timer To TRUE
          // Calculate The Timer Resolution Using The Timer Frequency
          timer.resolution    = (float) (((double)1.0f)/((double)timer.frequency));
          // Set The Elapsed Time To The Current Time
          timer.performance_timer_elapsed = timer.performance_timer_start;
     }
}

// Get Time In Milliseconds ( Add )
float TimerGetTime()
{
     __int64 time;        
	// 'time' Will Hold A 64 Bit Integer
     if (timer.performance_timer)						// Are We Using The Performance Timer?
     {
          QueryPerformanceCounter((LARGE_INTEGER *) &time);	// Grab The Current Performance Time
          // Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
          return ( (float) ( time - timer.performance_timer_start) * timer.resolution)*1000.0f;
     }
     else
     {
          // Return The Current Time Minus The Start Time Multiplied By The Resolution And 1000 (To Get MS)
          return( (float) ( timeGetTime() - timer.mm_timer_start) * timer.resolution)*1000.0f;
     }
}

void readstr(FILE *f,char *string)
{
	do
	{
		fgets(string, 255, f);
	} while ((string[0] == '/') || (string[0] == '\n'));
	return;
}

void SetupWorld()
{
	float x, y, z, u, v;
	int numtriangles;
	FILE *filein;
	char oneline[255];
	filein = fopen("data/world.txt", "rt");				// File To Load World Data From

	readstr(filein,oneline);
	sscanf(oneline, "NUMPOLLIES %d\n", &numtriangles);

	sector1.triangle = new TRIANGLE[numtriangles];
	sector1.numtriangles = numtriangles;
	for (int loop = 0; loop < numtriangles; loop++)
	{
		readstr(filein,oneline);						// ( Add )
		sscanf(oneline, "%i\n", &sector1.triangle[loop].texture);	// ( Add )

		for (int vert = 0; vert < 3; vert++)
		{
			readstr(filein,oneline);
			sscanf(oneline, "%f %f %f %f %f %f %f", &x, &y, &z, &u, &v);
			sector1.triangle[loop].vertex[vert].x = x;
			sector1.triangle[loop].vertex[vert].y = y;
			sector1.triangle[loop].vertex[vert].z = z;
			sector1.triangle[loop].vertex[vert].u = u;
			sector1.triangle[loop].vertex[vert].v = v;
		}
	}
	fclose(filein);
	return;
}

AUX_RGBImageRec *LoadBMP(char *Filename)                // Loads A Bitmap Image
{
        FILE *File=NULL;                                // File Handle

        if (!Filename)                                  // Make Sure A Filename Was Given
        {
                return NULL;                            // If Not Return NULL
        }

        File=fopen(Filename,"r");                       // Check To See If The File Exists

        if (File)                                       // Does The File Exist?
        {
                fclose(File);                           // Close The Handle
                return auxDIBImageLoad(Filename);       // Load The Bitmap And Return A Pointer
        }
        return NULL;                                    // If Load Failed Return NULL
}

int LoadGLTextures()                                    // Load Bitmaps And Convert To Textures
{
    int Status=FALSE;									// Status Indicator
    AUX_RGBImageRec *TextureImage[5];					// Create Storage Space For The Textures
    memset(TextureImage,0,sizeof(void *)*5);			// Set The Pointer To NULL
    if ((TextureImage[0]=LoadBMP("Data/floor1.bmp")) &&	// Load The Floor Texture
        (TextureImage[1]=LoadBMP("Data/light1.bmp")) &&	// Load the Light Texture
        (TextureImage[2]=LoadBMP("Data/rustyblue.bmp")) &&	// Load the Wall Texture
        (TextureImage[3]=LoadBMP("Data/crate.bmp")) &&	// Load the Crate Texture
        (TextureImage[4]=LoadBMP("Data/weirdbrick.bmp")))	// Load the Ceiling Texture
	{   
		Status=TRUE;									// Set The Status To TRUE
		glGenTextures(5, &texture[0]);					// Create The Texture
		for (int loop1=0; loop1<5; loop1++)				// Loop Through 5 Textures
		{
			glBindTexture(GL_TEXTURE_2D, texture[loop1]);
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[loop1]->sizeX, TextureImage[loop1]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[loop1]->data);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		}
		for (loop1=0; loop1<5; loop1++)					// Loop Through 5 Textures
		{
			if (TextureImage[loop1])					// If Texture Exists
			{
				if (TextureImage[loop1]->data)			// If Texture Image Exists
				{
					free(TextureImage[loop1]->data);	// Free The Texture Image Memory
				}
				free(TextureImage[loop1]);				// Free The Image Structure 
			}
		}
	}
	return Status;										// Return The Status
}


GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())								// Jump To Texture Loading Routine
	{
		return FALSE;									// If Texture Didn't Load Return FALSE
	}

	glEnable(GL_TEXTURE_2D);							// Enable Texture Mapping
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);					// Set The Blending Function For Translucency
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);				// This Will Clear The Background Color To Black
	glClearDepth(1.0);									// Enables Clearing Of The Depth Buffer
	glDepthFunc(GL_LESS);								// The Type Of Depth Test To Do
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glShadeModel(GL_SMOOTH);							// Enables Smooth Color Shading
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	SetupWorld();

	return TRUE;										// Initialization Went OK
}

int DrawGLScene(GLvoid)									// Here's Where We Do All The Drawing
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);	// Clear The Screen And The Depth Buffer
	glLoadIdentity();									// Reset The View

	GLfloat x_m, y_m, z_m, u_m, v_m;
	GLfloat xtrans = -xpos;
	GLfloat ztrans = -zpos;
	GLfloat ytrans = -walkbias-0.25f;
	GLfloat sceneroty = 360.0f - yrot;

	int numtriangles;

	glRotatef(lookupdown,1.0f,0,0);
	glRotatef(sceneroty,0,1.0f,0);
	
	glTranslatef(xtrans, ytrans, ztrans);
	numtriangles = sector1.numtriangles;
	
	// Process Each Triangle
	for (int loop_m = 0; loop_m < numtriangles; loop_m++)
	{
		glBindTexture(GL_TEXTURE_2D, texture[sector1.triangle[loop_m].texture]);	// ( Modified )

		glBegin(GL_TRIANGLES);
			glNormal3f( 0.0f, 0.0f, 1.0f);
			x_m = sector1.triangle[loop_m].vertex[0].x;
			y_m = sector1.triangle[loop_m].vertex[0].y;
			z_m = sector1.triangle[loop_m].vertex[0].z;
			u_m = sector1.triangle[loop_m].vertex[0].u;
			v_m = sector1.triangle[loop_m].vertex[0].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[1].x;
			y_m = sector1.triangle[loop_m].vertex[1].y;
			z_m = sector1.triangle[loop_m].vertex[1].z;
			u_m = sector1.triangle[loop_m].vertex[1].u;
			v_m = sector1.triangle[loop_m].vertex[1].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);
			
			x_m = sector1.triangle[loop_m].vertex[2].x;
			y_m = sector1.triangle[loop_m].vertex[2].y;
			z_m = sector1.triangle[loop_m].vertex[2].z;
			u_m = sector1.triangle[loop_m].vertex[2].u;
			v_m = sector1.triangle[loop_m].vertex[2].v;
			glTexCoord2f(u_m,v_m); glVertex3f(x_m,y_m,z_m);
		glEnd();
	}
	return TRUE;										// Everything Went OK
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);					// If So Switch Back To The Desktop
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}
	
	ShowCursor(FALSE);    // Hide Mouse Pointer (Modified)

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

	if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

// Initializes Direct Input ( Add )
int DI_Init()
{
    // Create Direct Input
    if ( DirectInputCreateEx( hInstance,			// Window Instance
        DIRECTINPUT_VERSION,						// Direct Input Version
        IID_IDirectInput7,							// Version 7
        (void**)&g_DI,								// Direct Input
        NULL ) )
    {
    return(false);									// Couldn't Initialize Direct Input
    }

    // Create The Keyboard Device
    if ( g_DI->CreateDeviceEx( GUID_SysKeyboard,	// Define Which Device To Create (KeyBoard,Mouse Or Joystick)
        IID_IDirectInputDevice7,					// Version 7
        (void**)&g_KDIDev,							// KeyBoard Device
        NULL ) )
    {
		// Couldn't Create The Keyboard Device
        return(false);								// Failed, Return False
    }

    if ( g_KDIDev->SetDataFormat(&c_dfDIKeyboard) )	// Set The Keyboard Data Format
    {
		// Couldn't Set The Data Format
        return(false);								// Failed, Return False
    }

    // Set The Cooperative Level
    if ( g_KDIDev->SetCooperativeLevel(hWnd, DISCL_FOREGROUND | DISCL_EXCLUSIVE) )
    {
		// Couldn't Set The Cooperative Level
        return(false);								// Failed, Return False
    }

    if (g_KDIDev)									// Did We Create The Keyboard Device?
        g_KDIDev->Acquire();						// If So, Acquire It
    else
        return(false);								// If Not, Return False

    return(true);									// Everything Went OK
}

// Destroys DX ( Add )
void DX_End()
{
    if (g_DI)
    {
        if (g_KDIDev)
        {
            g_KDIDev->Unacquire();
            g_KDIDev->Release();
            g_KDIDev = NULL;
        }
        g_DI->Release();
        g_DI = NULL;
    }
}


LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			// Instance
					HINSTANCE	hPrevInstance,		// Previous Instance
					LPSTR		lpCmdLine,			// Command Line Parameters
					int			nCmdShow)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	//new variables for movement
	float timer; //used to check the current time
	float timerdiff; //used to determine the time elapsed
	float secsperframe; //used to hold the value for how many seconds have elapsed between frames
	float desireddistance; //desired distance to move in a second
	float movementvalue; //value to move by each frame

	desireddistance=2.0f;

	// Ask The User Which Screen Mode They Prefer
	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;							// Windowed Mode
	}

	// Create Our OpenGL Window
	if (!CreateGLWindow("Justin Eslinger's & NeHe's Advanced DirectInput Tutorial",640,480,16,fullscreen))	// ( Modified )
	{
		return 0;									// Quit If Window Was Not Created
	}

	if (!DI_Init())									// Initialize DirectInput ( Add )
	{
		return 0;									// Couldn't Initialize, Quit
	}

	TimerInit();									// Init Our Timer ( Add )
	timer = TimerGetTime();

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		{
			float start=TimerGetTime();				// Grab Timer Value Before We Draw	( Add )

			// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
			if ((active && !DrawGLScene())) // Active?  Was There A Quit Received?		( Modified )			
			{
				done=TRUE;							// ESC or DrawGLScene Signalled A Quit
			}
			else									// Not Time To Quit, Update Screen
			{
				//remove old code
				//while(TimerGetTime()<start+float(adjust*2.0f)) {} // Waste Cycles On Fast Systems ( Add )

				//first determine how many seconds elapsed
				timerdiff = TimerGetTime()-timer;

				//the function reads in milliseconds so convert to seconds
				secsperframe=(float)(timerdiff/1000.0f);

				//now compute the movement value
				movementvalue = (float)(desireddistance*secsperframe);

				//get the new time
				timer = TimerGetTime();

				SwapBuffers(hDC);					// Swap Buffers (Double Buffering)

				GetCursorPos(&mpos);				// Get The Current Mouse Position	( Add )

				SetCursorPos(320,240);				// Set The Mouse Position To The Center Of The Window	( Add )

				heading += (float)(320 - mpos.x)/100 * 5;         // Update The Direction For Movement		( Add )
				yrot = heading;                                   // Update The Y Rotation	( Add )
				lookupdown -= (float)(240 - mpos.y)/100 * 5;      // Update The X Rotation	( Add )

				// Get The Keys That Have Been Pressed	( Add )
				HRESULT hr = g_KDIDev->GetDeviceState(sizeof(buffer), &buffer);

				if ( buffer[DIK_ESCAPE] & 0x80 )	// Check For Escape Key ( Modified )
				{
					done=TRUE;						// If Escape Is Pressed Set 'done' To True
				}

				if ( buffer[DIK_B] & 0x80)			// B Key Being Pressed? ( Modified )
				{
					if (!bp)
					{
						bp = true;					// Is The Blend Button Down?	( Add )
						blend=!blend;				// Toggle Blending On/Off
						if (!blend)					// Is Blending Off?
						{
							glDisable(GL_BLEND);	// If So, Disable Blending
							glEnable(GL_DEPTH_TEST);// Enable Depth Testing
						}
						else						// Otherwise
						{
							glEnable(GL_BLEND);		// Enable Blending
							glDisable(GL_DEPTH_TEST);	// Disable Depth Testing
						}
					}
				}
				else
				{
					bp = false;						// Set 'bp' To False
				}

				if ( buffer[DIK_PRIOR] & 0x80 )		// Page Up? ( Modified )
				{
					z-=0.02f;						// Decrease 'z' by 0.02f
				}

				if ( buffer[DIK_NEXT] & 0x80 )		// Page Down? ( Modified )
				{
					z+=0.02f;						// Increase 'z' by 0.02f
				}

				if ( buffer[DIK_UP] & 0x80 )		// Up Arrow ( Modified )
				{
					//old code
					//xpos -= (float)sin(heading*piover180) * 0.05f;
					//zpos -= (float)cos(heading*piover180) * 0.05f;

					//new code
					xpos -= (float)sin(heading*piover180) * movementvalue;
					zpos -= (float)cos(heading*piover180) * movementvalue;

					if (walkbiasangle >= 359.0f)
					{
						walkbiasangle = 0.0f;
					}
					else
					{
						//old code
						//walkbiasangle+= 10;

						//new code
						walkbiasangle+=(400.0f*secsperframe);
					}

					walkbias = (float)sin(walkbiasangle * piover180)/20.0f;
				}

				if ( buffer[DIK_DOWN] & 0x80 )		// Down Arrow ( Modified )
				{
					//old code
					//xpos += (float)sin(heading*piover180) * 0.05f;
					//zpos += (float)cos(heading*piover180) * 0.05f;

					//new code
					xpos += (float)sin(heading*piover180) * movementvalue;
					zpos += (float)cos(heading*piover180) * movementvalue;

					if (walkbiasangle <= 1.0f)
					{
						walkbiasangle = 359.0f;
					}
					else
					{
						//old code
						//walkbiasangle-= 10;

						//new code
						walkbiasangle-=(400.0f*secsperframe);
					}

					walkbias = (float)sin(walkbiasangle * piover180)/20.0f;
				}

				if ( buffer[DIK_LEFT] & 0x80 )		// ( Modified )
				{
					//old code
					//xpos += (float)sin((heading - 90)*piover180) * 0.05f;	// ( Modified )
					//zpos += (float)cos((heading - 90)*piover180) * 0.05f;	// ( Modified )

					//new code
					xpos += (float)sin((heading - 90)*piover180) * movementvalue;
					zpos += (float)cos((heading - 90)*piover180) * movementvalue;

					if (walkbiasangle <= 1.0f)		// ( Modified )
					{
						walkbiasangle = 359.0f;		// ( Modified )
					}
					else
					{
						//old code
						//walkbiasangle-= 10;			// ( Modified )

						//new code
						walkbiasangle-=(400.0f*secsperframe);
					}

					walkbias = (float)sin(walkbiasangle * piover180)/20.0f;	// ( Modified )
				}

				if ( buffer[DIK_RIGHT] & 0x80 )		// ( Modified )
				{
					//old code
					//xpos += (float)sin((heading + 90)*piover180) * 0.05f;	// ( Modified )
					//zpos += (float)cos((heading + 90)*piover180) * 0.05f;	// ( Modified )

					//new code
					xpos += (float)sin((heading + 90)*piover180) * movementvalue;
					zpos += (float)cos((heading + 90)*piover180) * movementvalue;

					if (walkbiasangle <= 1.0f)		// ( Modified )
					{
						walkbiasangle = 359.0f;		// ( Modified )
					}
					else
					{
						//old code
						//walkbiasangle-= 10;			// ( Modified )

						//new code
						walkbiasangle-=(400.0f*secsperframe);
					}

					walkbias = (float)sin(walkbiasangle * piover180)/20.0f;	// ( Modified )
				}

				if ( buffer[DIK_F1] & 0x80)			// Is F1 Being Pressed?				( Modified )
				{
					if (!fp)						// If F1 Isn't Being "Held"			( Add )
					{
						fp = true;					// Is The F1 Button Down?			( Add )
						KillGLWindow();				// Kill Our Current Window			( Modified )
						fullscreen=!fullscreen;		// Toggle Fullscreen/Windowed Mode	( Modified )

						// Recreate Our OpenGL Window
					    if (!CreateGLWindow("Justin Eslinger's & NeHe's Advanced Direct Input Tutorial",640,480,16,fullscreen))	// ( Modified )
						{
							return 0;				// Quit If Window Was Not Created ( Modified )
						}

						if (!DI_Init())				// ReInitialize DirectInput ( Add )
						{
							return 0;				// Couldn't Initialize, Quit
						}
					}
				}
				else
				{
					fp = false;						// Set 'fp' To False
				}
			}
		}
	}

	// Shutdown
	DX_End();										// Destroys DX	( Add )
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}
